function [] = write_ENVI(A,name,directory)
% A represents the image data.
% name is the output name of the result.ȱʧ
% directory means the storage location.ȱʧ

if nargin == 3 || 2
    str = name;
else
    str = 'default';   
end

[M,N,band] = size(A);

for i = 1 : band
    B(:,:,i) = A(:,:,i)';
end

Envi_form = reshape(B,M*N*band,1);

if nargin == 3
    enviwrite(Envi_form,N,M,band,str,directory);
else
    enviwrite(Envi_form,N,M,band,str);
end


function i=enviwrite(image,width,height,bds,fname1,dir)
%
% enviwrite          	- write ENVI image from MATLAB array (V. Guissard, Apr 29 2004)
%
% 				Write a MATLAB array to a file in ENVI standard format
%				from a [col x line x band] array
%
% INPUT :
%
%
% image	c by l by b	name of the MATLAB variable containing the array to export
%				to an ENVI image, with c = cols, l the lines and b the bands
% fname	string	full pathname of the ENVI image to write.
%
% OUTPUT :
%
% i		integer	i = -1 if process fail
%
% NOTE : 			
%
%%%%%%%%%%%%%
fname2 = fname1;
if nargin == 6
    fname=[dir fname1];
else
    fname=fname1;
end

elements={'samples =' 'lines   =' 'bands   =' 'data type ='};
% Check user input
if ~ischar(fname)
    error('fname should be a char string');
end

cl1=class(image);
if strcmpi(cl1,'double')
    img=double(image);
else
    img=image;
end

cl=class(img);
switch cl
    case 'single'
        t = 4;
    case 'int16'
        t = 2;
    otherwise
        error('Data type not recognized');
end
wfid = fopen(fname,'w');
if wfid == -1
    i=-1;
end
disp(['  дENVIӰļ ',fname2,' ɹ!  ']);
% image=reshape(image,[im_size(1)*im_size(2),im_size(3)]);
fwrite(wfid,image',cl);
fclose(wfid);

% Write header file

fid = fopen(strcat(fname,'.hdr'),'w');
if fid == -1
   i=-1;
end

fprintf(fid,'%s \n','ENVI');
fprintf(fid,'%s \n','description = {');
fprintf(fid,'%s \n','Exported from MATLAB}');
fprintf(fid,'%s %i \n',elements{1,1},width);
fprintf(fid,'%s %i \n',elements{1,2},height);
fprintf(fid,'%s %i \n',elements{1,3},bds);
fprintf(fid,'%s %i \n',elements{1,4},t);
fprintf(fid,'%s \n','interleave = bsq');
fclose(fid);